﻿<?php 
	require_once('Loader.class.php');
	class ImportarCSV 
	{ 
		private $ponteiro_arquivo; 
		private $analise_cabecalho; 
		private $cabecalho; 
		private $separador; 
		private $tamanho; 
		
		function __construct($arquivo, $analise_cabecalho=false, $separador="\t", $tamanho=8000) 
		{ 
			try{
				$this->ponteiro_arquivo = fopen($arquivo, "r"); 
				$this->analise_cabecalho = $analise_cabecalho; 
				$this->separador = $separador; 
				$this->tamanho = $tamanho; 
				
				if ($this->analise_cabecalho) 
				{ 
				   $this->cabecalho = fgetcsv($this->ponteiro_arquivo, $this->tamanho, $this->separador); 
				} 
			}
			catch(Exception $e){
				echo "Erro: ".$e->getMessage();
			}
		} 

		function __destruct() 
		{ 
			if ($this->ponteiro_arquivo) 
			{ 
				fclose($this->ponteiro_arquivo); 
			} 
		} 

		function getInformacoes($max_linhas=0) 
		{  

			$informacoes = array(); 

			if ($max_linhas > 0) 
				$linha_atual = 0; 
			else 
				$linha_atual = -1; 

			while ($linha_atual < $max_linhas && ($linha = fgetcsv($this->ponteiro_arquivo, $this->tamanho, $this->separador)) !== FALSE) 
			{ 
				if ($this->analise_cabecalho) 
				{ 
					foreach ($this->cabecalho as $i => $titulo_atual) 
					{ 
						$nova_linha[$titulo_atual] = $linha[$i]; 
					} 
					$informacoes[] = $nova_linha; 
				} 
				else 
				{ 
					$informacoes[] = $linha; 
				} 

				if ($max_linhas > 0) 
					$linha_atual++; 
			} 
			return $informacoes; 
		} 
		

	} 
?>