﻿<?php
	/*
	*	Trabalho/Seminário de Linguagem de Programação 2014/2
	*	Professor: Vitor Souza
	*	Alunos: Nicholas Figueiredo	e Marini Favero
	*	Descrição: 
	*/

	// Classes:
	require_once('classes/Loader.class.php');
	
	// Funções:
	include('includes/funcoes.php');
	
	// Diretório de Arquivos de Entrada:
	$Inpath = "csv/in/";
	
	// Diretório de Arquivo de Saída:
	$Outpath = "csv/out/";
	
	// Pegar Diretorio e Inicializar Array de Arquivos de Entrada.
	$diretorio = dir($Inpath);
	$InCSV = array(5);
	
	// Listas de Relatorios inicializadas
	$listAPagar = array();
	$listAReceber = array();
	$listVendasProd = array();
	$listVendasPgto = array();
	$listEstoque = array();
	
	// Localizando Arquivos de Entrada e Armazenandos em ordem de prioridade de cadastros
	while($arquivo = $diretorio -> read()){
		if($arquivo != "." && $arquivo != ".."){
			$nameFile = basename($arquivo,".csv");
			if(strcasecmp($nameFile,"clientes")==0) $InCSV[0] = $Inpath.$arquivo; //Código;Nome;Endereço;Telefone;Data de cadastro;Tipo de cliente;CPF/CNPJ;Inscrição estadual
			elseif(strcasecmp($nameFile,"fornecedores")==0) $InCSV[1] = $Inpath.$arquivo; //Código;Nome;Endereço;Telefone;CNPJ;Pessoa de contato
			elseif(strcasecmp($nameFile,"produtos")==0) $InCSV[2] = $Inpath.$arquivo; //Código;Descrição;Estoque mínimo;Estoque atual;Valor de custo;Percentual de lucro
			elseif(strcasecmp($nameFile,"compras")==0) $InCSV[3] = $Inpath.$arquivo; //Nota fiscal;Fornecedor;Data da compra;Produto;Quantidade
			elseif(strcasecmp($nameFile,"vendas")==0) $InCSV[4] = $Inpath.$arquivo; //Cliente;Data de venda;Produto;Quantidade;Modo de pagamento
		}
	}
	
	for($i=0;$i<sizeof($InCSV);$i++){
	
		// Carregando Dados dos arquivos de Entrada
		echo "Carregando dados de ".$InCSV[$i]." ... <br/>";
		$nameFile = basename($InCSV[$i],".csv");
		$importar = new ImportarCSV($InCSV[$i],true,";");
		$info = $importar->getInformacoes();
		
		// Processamento de Dados.
		echo "Instanciando Objetos do array ".$nameFile." ... <br/>";
		$$nameFile = array();
		$$nameFile = criaObjetos($info,$nameFile);
		
		//Preenche a Lista APagar
		
		if(isset($fornecedores) && isset($compras) && isset($produtos)){
			echo "Preenchendo o array listAPagar ... <br/>";
			for($c=0;$c<sizeof($compras);$c++){
				$forn = Fornecedor::getFornecedorById($fornecedores,$compras[$c]->getFornecedor());
				$listAPagar[] = array($forn->getNome(),$forn->getCNPJ(),$forn->getContato(),$forn->getTelefone(),$compras[$c]->getValorPago($produtos));
			}
		}
		
		//Preenche a Lista AReceber
		if(isset($clientes) && isset($vendas) && isset($produtos)){
			echo "Preenchendo o array listAReceber ... <br/>";
			for($v=0;$v<sizeof($vendas);$v++){
				$cli = Cliente::getClienteById($clientes,$vendas[$v]->getCliente());
				switch(get_class($cli)[0]){
					case "F":
						$listAReceber[] = array($cli->getNome(),get_class($cli)[0],$cli->getCPF(),$cli->getTelefone(),$cli->getDataCadastro(),$vendas[$v]->getValorVendido($produtos));
						break;
					case "J":
						$listAReceber[] = array($cli->getNome(),get_class($cli)[0],$cli->getCNPJ(),$cli->getTelefone(),$cli->getDataCadastro(),$vendas[$v]->getValorVendido($produtos));
						break;
				}
			}
		}
		
		// Funções Usadas Para Visualização em "Tela" dos Dados de Entrada.
		//GeradorTabelas($info,$nameFile);
		//imprimirArray($$nameFile);
	}
	
	
	//Ordenando Listas
	echo "Ordenando listAPagar pelo Fornecedor ... <br/>";
	usort($listAPagar,"Fornecedor::cmpFornecedor");
	echo "Ordenando listAReceber pelo Cliente ... <br/>";
	usort($listAReceber,"Cliente::cmpCliente");
	
	//imprimirArray($listAPagar);
	$OutCSV = array("apagar.csv","areceber.csv","vendasprod.csv","vendaspgto.csv","estoque.csv");
	$CabecalhoCSV = array(
		array("Fornecedor","CNPJ","Pessoa de contato","Telefone","Total a pagar"),
		array("Cliente","Tipo","CPF/CNPJ","Telefone","Data de Cadastro","Total a pagar"),
		array("Código","Produto","Receita bruta","Lucro"),
		array("Modo de pagamento","Receita bruta","Lucro"),
		array("Código","Produto","Quantidade em estoque","Observações")
	);
	if(!is_dir($Outpath)){
		echo "Diretorio de Saída não existe, e será criado: ".$Outpath." ... <br/>";
		$create = mkdir($Outpath,0777);
		if(!$create)
			throw new Exception("O sistema não tem permissão de criar o diretorio:".$Outpath);
	}
	
	$tipoEscrita = "ReadAndWrite";
	$inicioEscrita = "Top";
	$delimitador = ";";
	for($i=0;$i<sizeof($OutCSV);$i++){
		echo "Criando/Abrindo arquivo ".$OutCSV[$i]."com cabeçalho, do tipo ".$tipoEscrita.", iniciando a escrita a partir do ".$inicioEscrita." e usando delimitador :".$delimitador." ... <br/>";
		$nameFile = basename($OutCSV[$i],".csv");
		$relatorio = new Relatorios($Outpath.$OutCSV[$i], true, $CabecalhoCSV[$i], $delimitador, $tipoEscrita, $inicioEscrita);
		switch($nameFile){
			case "apagar":
				echo "preenchendo relatório apagar.csv ... <br/>";
				$relatorio->getRelatorio($listAPagar);
				break;
			case "areceber":
				echo "preenchendo relatório areceber.csv ... <br/>";
				$relatorio->getRelatorio($listAReceber);
				break;
			case "vendasprod":
				//$relatorio->getRelatorio();
				break;
			case "vendaspgto":
				//$relatorio->getRelatorio();
				break;
			case "estoque":
				//$relatorio->getRelatorio();
				break;
		}
	}
	echo "Fechando Diretorio <br/>";
	$diretorio-> close();
	/*
	* Descrições de Funções:
	* 
	*/
?>
